*******************************************************************************
* Filename: eql4931a.s
* Author: James D. Purdy
* Description: eql49 equation library browser
* Revision: release 2.2
* Revision date: 1/16/2000
* Stack diagram:
*       ( --> )
*******************************************************************************
INCLUDE Header.h

DEFINE USERFLAG # 5   ( flag for standalone mode )
RPL
EXTERNAL Choose

::
RECLAIMDISP ClrDA1IsStat CLEARMENU
#0 "Loading..." $>GROB  Grob>Menu
{ "Equation Library v2.2" }   ( Build  library list )
USERFLAG TestUserFlag NOT IT :: 1009 1 #>ROMPTR EVAL  >TCOMP ;
' ID USEREQ SAFE@_HERE IT >TCOMP

TRUE
NULL$
NULL{}    ( place holder for info list )

' ::   ( build menu subr )
  CLEARMENU
  EIGHT TWENTYONE MAKEGROB
  DUP 0 SWAP Grob>Menu
  22 SWAP Grob>Menu
  44 "INFO" MakeInvLabel Grob>Menu
  66 "RCL" MakeInvLabel Grob>Menu
  88 "MSLV" MakeInvLabel Grob>Menu
  110 "SLV" MakeInvLabel Grob>Menu
;

' ::   ( start solver subr )
        2GETLAM
       DUPLENCOMP #1+ ONE DO DUP CARCOMP SWAP CDRCOMP SWAP STRIPTAGS >TCOMP LOOP  ;

' ::  ( get eq from list subr ) 
   2GETLAM 4GETLAM NTHCOMPDROP ;

' ::    ( CHOOSER subr -- list, title )

  ' ::
     SIXTY #=casedrop :: TRUE TRUE ;
     FIVETHREE #=casedrop    ::
        ' ::   NoExitAction
            {
              { "Back" :: TakeOver TRUE DoCKeyCancel ; }
              NullMenuKey
              NullMenuKey
              NullMenuKey
              { "Cancl"  DoCKeyCancel  }
              { "Ok" :: TakeOver 18GETLAM DoCKeyOK ; }
             }  ;
             TRUE ;
     DROPFALSE
   ;
  SWAP ROT
  ' ::  ( ob decompiler )
        DUPTYPELIST? IT :: ONE NTHCOMPDROP ;
        DUPTYPECSTR? ?SEMI
        DUPTYPESYMB? ?SEMI
        DO>STR
   ;
  SWAP
  ONE
  Choose
; ( ___ end of chooser ___ )

' ONE           ( pointers )
' ONE
' NULL{}        ( item list )
' TRUE          ( running )

' NULLLAM       ( 12 eq/info list )
' NULLLAM       ( 11 loop var )
' NULLLAM       ( 10 Title  )
' NULLLAM       ( 9 Temporary )
' NULLLAM       ( 8 Menu setup subr )
' NULLLAM       ( 7 striptrags and solver subr )
' NULLLAM       ( 6 get eq sub )
' NULLLAM       ( 5 chooser sub )
' NULLLAM       ( 4 list pointer )
' NULLLAM       ( 3 list size )
' NULLLAM       ( 2 item list )
' NULLLAM       ( 1 Running )
TWELVE DOBIND

USERFLAG TestUserFlag IT ::
% 9  xTVARS   ( get equations from current directory ) 
  DUPLENCOMP
  #0= NOT ITE 
  ::  DUPLENCOMP #1+ ONE DO DUP CARCOMP SWAP CDRCOMP SWAP DUP SAFE@_HERE DROPSWAP ID>TAG >TCOMP LOOP
       NULL$ 9PUTLAM PATHDIR DUPLENCOMP DUP #1= ITE
         :: 2DROP "Home" # 5C >T$ 9PUTLAM ;
         ::  SWAP CDRCOMP ID Home >HCOMP SWAP
             #1+ ONE DO
                  DUP INDEX@ NTHCOMPDROP ID>$ 9GETLAM
                  SWAP &$ # 5C >T$ 9PUTLAM
                LOOP  DROP ;
         9GETLAM >HCOMP 12GETLAM SWAP >TCOMP 12PUTLAM NULL{} 9PUTLAM ;
  :: DROP ;
% 15 xTVARS DUPLENCOMP DUP #0= NOT ITE :: #1+   ( get equations from all subdirectories )
ONE DO DUP INDEX@ NTHCOMPDROP
  DUP
  EVAL  % 9  xTVARS 
  DUPLENCOMP
  #0= NOT ITE 
  ::   DUPLENCOMP #1+ ONE DO DUP CARCOMP SWAP CDRCOMP SWAP DUP SAFE@_HERE DROPSWAP ID>TAG >TCOMP LOOP
        SWAP ID>$ # 3C >H$ # 3E >T$  >HCOMP  12GETLAM SWAP
       >TCOMP 12PUTLAM ;
  :: 2DROP ;
  UPDIR  LOOP ;  :: DROP  ;
  DROP
;

12GETLAM DUPLENCOMP #1= ITE DROPTRUE FALSE  ?SEMI

DUP 2PUTLAM  ' ID ^^ STO  NULL{} 12PUTLAM    ( drop the list and free 8 )


BEGIN        ( start of main loop )
1GETLAM
WHILE

 CLEARVDISP

 BEGIN       ( start of inner/chooser  loop )
 1GETLAM
 WHILE
  2GETLAM
  DUP TWO NTHCOMPDROP                    ( returns first object )
  TYPELIST? ITE ::                       ( which does not hve a list )
                  DUP ONE NTHCOMPDROP    ( in element two )
                  SWAP CDRCOMP SWAP
                  5GETLAM EVAL
                  ITE :: SWAP DUPTYPEBINT?  
                         ITE :: SWAP DUPTYPELIST?
                                ITE :: 2PUTLAM 9GETLAM SWAP >TCOMP 9PUTLAM ;
                                    :: FALSE FALSE 1PUTLAM ;
                             ;
                             :: DROP RECLAIMDISP TRUEFALSE 1PUTLAM ;   ( enter pressed, so exit )
                      ;
                      :: TRUE #=casedrop :: 9GETLAM DUPLENCOMP #1 #>      ( flase true back key pressed )
                                            ITE :: INNERCOMP #1- SWAPDROP {}N ;  ( nip off last ob in list )
                                                :: DROP NULL{} ;  9PUTLAM
                                            ' ID ^^ SAFE@_HERE DROP 9GETLAM LENCOMP 2DUP
                                             #0= SWAP #1= OR   
                                             ITE ::  DROP ;
                                                 :: ONE DO  ( move down to last menu )
                                                         9GETLAM INDEX@ NTHCOMPDROP
                                                         #1+ NTHCOMPDROP
                                                        LOOP
                                                 ;  2PUTLAM  ;
                         FALSE #=casedrop ::  RECLAIMDISP TRUEFALSE 1PUTLAM ;  ( false false cancel key pressed )
                         RECLAIMDISP TRUEFALSE 1PUTLAM                         ( false null? on key pressed )
                      ;
                ;
                :: FALSE FALSE 1PUTLAM ;
 REPEAT
 ?SEMI   ( ---> EXIT )

       DUP CARCOMP $>grob 10PUTLAM  ( get title "first obj" and store title as grob )
       CDRCOMP DUP ONE NTHCOMPDROP
       ::                     ( file pointer or if user mode, eq's )
          DUPTYPESYMB? casedrop :: { 0 "No Information" } 12PUTLAM ;
          DUPTYPETAG? case :: STRIPTAGS DUPTYPELIST?
                                        ITE  :: 12PUTLAM  CDRCOMP ;
                                             :: DROP { 0 "No Information" } 12PUTLAM ;
                                        ;
          SWAPDROP INCOMPDROP % 1009  SWAP  256 33  #>ROMPTR  EVAL EVAL
          DUP CARCOMP 12PUTLAM                       ( store info list LAM 10 )
          CDRCOMP                                    ( get the object from the lib )
       ;
       DUPLENCOMP 3PUTLAM 2PUTLAM                ( calulate EQlist size )
       TRUE 1PUTLAM                              ( flag the loop )

 8GETLAM EVAL ( build menu )

 BEGIN    ( start of equation browser loop )
 1GETLAM
 WHILE

    #0 #0 10GETLAM XYGROBDISP    ( display title )
    2GETLAM 4GETLAM  NTHCOMPDROP
    %0 x>GROB DUPGROBDIM
    DUP 130 #> ITE  ( calculate coodinates to put grob in ctr, if too BIG put at 0,0 )
                 :: DROP #0 SWAP 52 SWAP#- #2/ ROT XYGROBDISP ;
                 :: 130 SWAP#- #2/ SWAP 52 SWAP#- #2/ ROT XYGROBDISP ;
    4GETLAM #>$ " of " &$ 3GETLAM #>$ &$ "  " &$ $>grob 0 SWAP Grob>Menu ( display # of # )

    WaitForKey  kpNoShift #=casedrop  ::   ( keyboard loop )
         kcOn #=casedrop :: RECLAIMDISP FALSE  FALSE 1PUTLAM ;
         kcEnter #=casedrop :: 6GETLAM EVAL STRIPTAGS ;
         kcBackspace #=casedrop ::
            CLEARMENU #0 "Loading..." $>GROB  Grob>Menu
            ' ID ^^ SAFE@_HERE DROP
           9GETLAM LENCOMP DUP
           #1= ITE :: DROP ;
                   :: ONE  DO 9GETLAM INDEX@ NTHCOMPDROP #1+ NTHCOMPDROP  LOOP ;
           2PUTLAM 9GETLAM  INNERCOMP #1- SWAPDROP  ( remove last value from list )
           {}N 9PUTLAM ONE 4PUTLAM
           TRUE  FALSE 1PUTLAM ;
         kcDownArrow #=casedrop ::               ( _ move point selector up ____ )
              ABUFF DUPGROBDIM SWAP 0 0 2SWAP GROB!ZERODRP
              4GETLAM ONE #+DUP 3GETLAM         ( point to next eq )
              #> ITE
              :: DROP ONE 4PUTLAM ;             ( If greater than end .. point to top )
              :: 4PUTLAM ;  ;
        kcUpArrow #=casedrop ::              ( ___ move point selector down ____ )
          ABUFF DUPGROBDIM SWAP 0 0 2SWAP GROB!ZERODRP
          4GETLAM ONE #-DUP ONE                 ( point to next eq )
          #< ITE
          :: DROP  3GETLAM 4PUTLAM ;            ( If greater than end .. point to top )
          :: 4PUTLAM ; ;
        kcRightArrow #=casedrop :: [BEGIN] SCROLLLEFT kcRightArrow REPKEY? NOT_UNTIL ;   ( fast scroller ) 
        kcLeftArrow #=casedrop :: [BEGIN]  SCROLLRIGHT kcLeftArrow REPKEY? NOT_UNTIL ;
        kcMenuKey3 #=casedrop ::  ( info key )
         CLEARMENU RECLAIMDISP 10GETLAM 0 SWAP Grob>Menu   ( clear all and display title in menu area )
         110 "OK" MakeInvLabel Grob>Menu
         12GETLAM DUPLENCOMP ONE #= IT :: INCOMPDROP % 1009 SWAP 256 33 #>ROMPTR EVAL EVAL ;
         DUP CARCOMP DUPTYPEGROB?
         ITE :: DUPGROBDIM 130 SWAP#- #2/ SWAP 58 SWAP#- #2/ ROT XYGROBDISP  ( center the grob )
                CDRCOMP DUPLENCOMP #1+
                ONE DO                                 ( display the variable info )
                       DUP INDEX@ NTHCOMPDROP $>GROB    ( below grob )
                       #0 ABUFF GROBDIM DROP
                       ROT XYGROBDISP ABUFF TWO HEIGHTENGROB
                  LOOP  DROP ;
             :: DROP "No Picture" $>GROB #0 #0 ROT XYGROBDISP ( else --- no pic )
                 CDRCOMP DUPLENCOMP #1+
                 ONE DO                                 ( display that info at 0,0 )
                       DUP INDEX@ NTHCOMPDROP $>GROB
                       #0 INDEX@ TEN #*
                       ROT XYGROBDISP ABUFF TWO HEIGHTENGROB
                 LOOP  DROP ;
         BEGIN
         1GETLAM
         WHILE      ( information scroller )
            WaitForKey :: DROP
                 kcRightArrow #=casedrop :: [BEGIN] SCROLLLEFT kcRightArrow REPKEY? NOT_UNTIL ;
                 kcLeftArrow #=casedrop :: [BEGIN]  SCROLLRIGHT kcLeftArrow REPKEY? NOT_UNTIL ;
                 kcDownArrow    #=casedrop :: [BEGIN] SCROLLUP kcDownArrow REPKEY? NOT_UNTIL ;
                 kcUpArrow  #=casedrop :: [BEGIN] SCROLLDOWN kcUpArrow REPKEY? NOT_UNTIL ;
                 kcMenuKey6 #=casedrop :: FALSE 1PUTLAM ;
                 DROP
            ;
        REPEAT
        TRUE 1PUTLAM  RECLAIMDISP
        8GETLAM EVAL ;  ( end of info scroller -- rebuild menu )
        kcMenuKey4 #=casedrop ::   ( rcl key )
          6GETLAM EVAL STRIPTAGS RECLAIMDISP
          FALSE FALSE 1PUTLAM ;
        kcMenuKey5 #=casedrop ::   ( msolve key )
          7GETLAM EVAL DUPLENCOMP #1 #>
                 ITE ::
                     RECLAIMDISP "Starting Solver" FOUR DISPN
                     ' ID EQ DoHere: STO " xMINIT xMSOLVR "
                     FALSE  FALSE 1PUTLAM ;
                     :: DROP  ; ;
        kcMenuKey6 #=casedrop ::   ( solve key )
         RECLAIMDISP "Starting Solver" FOUR DISPN
         7GETLAM EVAL
         ' ID EQ DoHere: STO DoSolvrMenu
          FALSE  FALSE 1PUTLAM ;
        kcSto #=casedrop ::         ( sto key )
          6GETLAM EVAL STRIPTAGS RECLAIMDISP
          ' ID EQ DoHere: STO FALSE FALSE 1PUTLAM ;
        kcEQW  #=casedrop ::         ( eqw key )
          6GETLAM EVAL STRIPTAGS RECLAIMDISP
          AlgObEdit FALSE FALSE 1PUTLAM  ;
        DROP ( disregard any other keys )
    ;
    kpLeftShift #=casedrop ::
         kcMenuKey5 #=casedrop ::   ( user msolve key )
          7GETLAM EVAL  RECLAIMDISP CLEARMENU
         ' ID ^^ PURGE   FALSE SWAP FALSE 1PUTLAM
         ' ID EQ DoHere: STO
         ' ID USOLVR @ IT  EVAL ;
        kcMenuKey6 #=casedrop ::   ( user solve key )        
         6GETLAM EVAL STRIPTAGS RECLAIMDISP CLEARMENU
         ' ID ^^ PURGE  FALSE SWAP FALSE 1PUTLAM
         ' ID EQ DoHere: STO
         ' ID USOLVR @ IT EVAL ;
        DROP
    ;
    kpRightShift     #=casedrop :: DROP ;
    kpANoShift       #=casedrop :: DROP ;
    kpALeftShft      #=casedrop :: DROP ;
    kpARightShft     #=casedrop :: DROP ;
    kpARightShift    #=casedrop :: DROP ;
    kpALeftShift     #=casedrop :: DROP ;
   
 REPEAT  ( return to loop inner loop )
 ITE TRUE FALSE 1PUTLAM
REPEAT  ( outer loop )
 ' ID ^^ PURGE
;


